%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXC:COMPILER.SL
% Description:  PSL Compiler.  
% Author:       Harold Carr & Leigh Stoller
% Created:      
% Modified:     
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% This file loads in all the compiler modules for lowiris.
%

(flag '(mkcode) 'lose)
(load datamachine
      pass-1
      pass-2-3
      comp-decls
      pass-1-lap
      lowiris-lap
      lowiris-cmac
      lowiris-comp
      backquote         % Needed for lowiris LAP patterns.
      registers
      lowiris-instrs
      lapopt
      faslout
      lowiris-spec)

(copyd 'inump 'fixp)
(setq *writingfaslfile nil)
(setq *writingasmfile nil)

% End of file.
