% compilation of multiple values
% multiple value return:

(put 'return 'ARGUMENT-COUNT nil)
(put 'values 'compfn '&COMRETURN)

% multiple value setq:
 
(put 'multiple-value-setq 'PASS-1-FUNCTION 'PA1F-multiple-value-setq)

(de PA1F-multiple-value-setq (u vbls)
    (let((exp (lastcar u))
         (n 0)
         (f nil)
         (r (cddr u)))
    (while (and r (cdr r))
           (setq n (add1 n))
           (push (list (nth '(setq2 setq3 setq4 setq5) n) 
                             `($name ,(recursive-pass-1 (car r) vbls))) f)
           (setq r (cdr r)))
    `(progn ,(recursive-pass-1 `(setq ,(cadr u) ,exp) vbls) . ,f)))
     
(put 'SETQ2       'OPENFN         '(SETQ2PAT NIL))
(put 'SETQ3       'OPENFN         '(SETQ3PAT NIL))
(put 'SETQ4       'OPENFN         '(SETQ4PAT NIL))
(put 'SETQ5       'OPENFN         '(SETQ5PAT NIL))

(put 'setq2pat 'pattern
     '(nil ('*destroy dest)
           (any                 ('*store '(reg 2) a1))))
(put 'setq3pat 'pattern
     '(nil ('*destroy dest)
           (any                 ('*store '(reg 3) a1))))
(put 'setq4pat 'pattern
     '(nil ('*destroy dest)
           (any                 ('*store '(reg 4) a1))))
(put 'setq5pat 'pattern
     '(nil ('*destroy dest)
           (any                 ('*store '(reg 5) a1))))



% (de otto()(prog() (return 17 4)))
 
% (de otto()(values 17 4))

% (de hugo(x Y)(multiple-value-setq x y (otto)) (list x y))
 

