%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXK:ARITH.SL
% Description:  Arithmetic required by the kernel.
% Author:       Brian Beach
% Created:      26-Jun-84
% Modified:     26-Jun-84 12:59:27
% Mode:         Lisp
% Package:      
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (remprop 'wquotient 'openfn))

(lap '((*entry wquotient expr 2)
	(*alloc 0)
	(lr (reg 3) (reg 2))  % 6
        (srda (reg 1) (displacement (reg r0) 32))
	(DR (reg 1) (reg 3))
	(*move (reg 2) (reg 1))
        (*exit 0)))

(lap '((*entry wremainder expr 2)
        (*alloc 0)
        (lr (reg 3) (reg 2))  % 6
        (srda (reg 1) (displacement (reg r0) 32))
        (DR (reg 1) (reg 3))
        (*exit 0)))

(lap '((*entry wtimes2 expr 2)
        (*alloc 0)
        (lr (reg 3) (reg 1))  % 6
        (mr (reg 1) (reg 3))  % r6, r7 = r7 * r8
        (slda (reg 1) (displacement (reg r0) 32)) 
                      % interrupt on overflow
        (*exit 0)))
